<h1 align="center">
  <br>
  <img width=20% src="https://github.com/tronprotocol/wiki/blob/master/images/java-tron.jpg?raw=true">
  <br>
  java-tron
  <br>
</h1>

<h4 align="center">
  Java implementation of the <a href="https://tron.network">Tron Protocol</a>
</h4>


<p align="center">
  <a href="https://discord.gg/GsRgsTD">
    <img src="https://img.shields.io/badge/chat-on%20discord-brightgreen.svg">
  </a>
    
  <a href="https://travis-ci.org/tronprotocol/java-tron">
    <img src="https://travis-ci.org/tronprotocol/java-tron.svg?branch=develop">
  </a>
  
  <a href="https://codecov.io/gh/tronprotocol/java-tron">
    <img src="https://codecov.io/gh/tronprotocol/java-tron/branch/develop/graph/badge.svg" />
  </a>
  
  <a href="https://github.com/tronprotocol/java-tron/issues">
    <img src="https://img.shields.io/github/issues/tronprotocol/java-tron.svg">
  </a>
  
  <a href="https://github.com/tronprotocol/java-tron/pulls">
    <img src="https://img.shields.io/github/issues-pr/tronprotocol/java-tron.svg">
  </a>
  
  <a href="https://github.com/tronprotocol/java-tron/graphs/contributors"> 
    <img src="https://img.shields.io/github/contributors/tronprotocol/java-tron.svg">
  </a>
  
  <a href="LICENSE">
    <img src="https://img.shields.io/github/license/tronprotocol/java-tron.svg">
  </a>
</p>

<p align="center">
  <a href="#quick-start">Quick Start</a> •
  <a href="#deploy">Deploy</a> •
  <a href="#developer-community">Developer Community</a> •
  <a href="http://developers.tron.network">Documentation</a> •
  <a href="#contributing">Contributing</a> •
  <a href="#projects">Projects</a> •
  <a href="#resource">Resource</a>
</p>

## What's TRON?

TRON is a project dedicated to building the infrastructure for a truly decentralized Internet.    


* Tron Protocol, one of the largest blockchain based operating systems in the world, offers scalable, high-availability and high-throughput support that underlies all the decentralized applications in the TRON ecosystem. 

* Tron Virtual Machine (TVM) allow anyone to develop decentralized applications (DAPPs) for themselves or their communities with smart contracts thereby making decentralized crowdfunding and token issuance easier than ever.

TRON enables large-scale development and engagement. With over 2000 transactions per second (TPS), high concurrency, low latency and massive data transmission. It is ideal for building decentralized entertainment applications. Free features and incentive systems allow developers to create premium app experiences for users.

# Quick Start

* [Quick Start](./quickstart.md) TRON Quickstart image setup

# Deploy
* [Build](./build.md) Please build java-tron after cloning the project  
* [Run](./run.md) Run java-tron

# Developer Community

* [Discord](https://discord.gg/GsRgsTD) Please join our Developer Discord
* [Gitter](https://gitter.im/tronprotocol/allcoredev) the core dev gitter

# Projects
* [TRON Protocol](https://github.com/tronprotocol/protocol)
* [Wallet Client](https://github.com/tronprotocol/wallet-cli)
* [Wallet Web](https://github.com/tronprotocol/wallet-web)

# Resource
* [Website](https://tron.network/)
* [Documentation](http://developers.tron.network)
* [Blog](https://tronprotocol.github.io/tron-blog/)
* [Tronscan](https://tronscan.org/)
* [Trxplorer](https://www.trxplorer.io/)
* [White Paper](https://tron.network/resources?lng=&name=1)
* [TRON Quickstart](https://developers.tron.network/docs/getting-started-1)
* [About](https://tron.network/about)
* [FAQ](https://tron.network/faq)

# Contributing
Thank you for all of [our contributors](https://github.com/tronprotocol/java-tron/graphs/contributors); this project wouldn’t be what it is without you! If you want to help out, please see [CONTRIBUTING.md](CONTRIBUTING.md).

If you'd like to contribute to java-tron, please fork, fix, commit and send a pull request for the maintainers to review and merge into the main code base.   
If you wish to submit more complex changes though, please check up with the core devs first on [our gitter channel](https://gitter.im/tronprotocol/allcoredev) to ensure those changes are 
in line with the general philosophy of the project and/or get some early feedback which can make both your efforts much lighter as well as our review and merge procedures quick and simple.

# License
* [MIT](https://github.com/tronprotocol/java-tron/blob/master/LICENSE)
